/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vsb.vis.visvzorservice;

import cz.vsb.vis.visvzor.model.Clovek;
import static cz.vsb.vis.visvzorservice.RepositoryType.JDBC;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class LideServiceImpl implements LideService {

    private List<Clovek> lide;

    private LideRepository lideRepository;

    public LideServiceImpl() {
        System.out.println("default LSI constructor");
    }

    public LideServiceImpl(LideRepositoryFactory lideRepositoryFactory) {
        lideRepository = lideRepositoryFactory.getManagedRepository();
    }

    @Override
    public void addClovek(Clovek clovek) {
        try {
            getLideRepository().ulozClovek(clovek);
        } catch (FileNotFoundException | UnsupportedEncodingException ex) {
            Logger.getLogger(LideServiceImpl.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    public int getPocetLidi() {
        return getLide().size();
    }

    @Override
    public Clovek getClovek(int pozice) {
        return getLide().get(pozice);
    }

    //Mockito isn't initialized yet when nactiLidi() is called from constructor.
    private List<Clovek> getLide() {
        return getLideRepository().nactiLidi();
    }

    private LideRepository getLideRepository() {
        if (lideRepository == null) {
            lideRepository = LideRepositoryFactory.getRepository(JDBC);
        }
        return lideRepository;
    }
}
