/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vsb.vis.visvzorservice;

import cz.vsb.vis.visvzor.model.Clovek;
import java.util.ArrayList;
import java.util.List;
import static org.junit.Assert.assertEquals;
import org.junit.Before;
import org.junit.Test;
import org.mockito.ArgumentCaptor;
import org.mockito.Captor;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;
import static org.mockito.MockitoAnnotations.initMocks;

/**
 *
 * @author nav79
 */
public class LideServiceTest {

    private final Clovek clovek = new Clovek("Petr", "Novak");

    @Mock
    private LideRepository lideRepository;

    @Mock
    private LideRepositoryFactory lideRepositoryFactory;

    @InjectMocks
    private LideServiceImpl serviceUnderTest;

    @Captor
    private ArgumentCaptor<List<Clovek>> lideCaptor;

    @Before
    public void setUp() {
        initMocks(this);
        List<Clovek> expectedLide = new ArrayList<>();
        expectedLide.add(clovek);
        when(lideRepositoryFactory.getManagedRepository()).thenReturn(lideRepository);
        when(lideRepository.nactiLidi()).thenReturn(expectedLide);
        serviceUnderTest = new LideServiceImpl(lideRepositoryFactory);
    }

    @Test
    public void testAddClovek() throws Exception {
        serviceUnderTest.addClovek(clovek);

        verify(lideRepository).ulozClovek(clovek);
    }

    @Test
    public void testGetPocetLidi() {
        int actualPocetLidi = serviceUnderTest.getPocetLidi();

        assertEquals(1, actualPocetLidi);
    }

    @Test
    public void testGetClovek() {
        Clovek actualClovek = serviceUnderTest.getClovek(0);

        assertEquals(clovek, actualClovek);
    }
}
